let
  fromEnv = var: def:
    let val = builtins.getEnv var; in
    if val != "" then val else def;
in rec {
  perl = "/nix/store/hkcdscirxy2hwxf0mjkqwj6p902rhw3i-perl-5.24.2/bin/perl";
  shell = "/nix/store/25wawwdkw7slg69jflsmjn7iwg5in2gs-bash-4.4-p12/bin/bash";
  coreutils = "/nix/store/8al5ha2xymy2kx138idgcg64hf7v1c88-coreutils-8.28/bin";
  bzip2 = "/nix/store/n6vi47y7ab4gr5i1jzb94nj4266wxmvl-bzip2-1.0.6.0.1-bin/bin/bzip2";
  gzip = "/nix/store/dqj2hm0saqkwqx3pncrfh0ngasf92il0-gzip-1.8/bin/gzip";
  xz = "/nix/store/lsl47bvdrw4llcdwzi6nswwdd4vdrc8b-xz-5.2.3-bin/bin/xz";
  tar = "/nix/store/8qjmq79hrl8i5j5zhayy5kl6vag08y00-gnutar-1.29/bin/tar";
  tarFlags = "--warning=no-timestamp";
  tr = "/nix/store/8al5ha2xymy2kx138idgcg64hf7v1c88-coreutils-8.28/bin/tr";
  nixBinDir = fromEnv "NIX_BIN_DIR" "/nix/store/dgwz3dxdzs2wwd7pg7cdhvl8rv0qpnbj-nix-1.11.15/bin";
  nixPrefix = "/nix/store/dgwz3dxdzs2wwd7pg7cdhvl8rv0qpnbj-nix-1.11.15";

  # If Nix is installed in the Nix store, then automatically add it as
  # a dependency to the core packages. This ensures that they work
  # properly in a chroot.
  chrootDeps =
    if dirOf nixPrefix == builtins.storeDir then
      [ (builtins.storePath nixPrefix) ]
    else
      [ ];
}
